#include <Windows.h>
#include <winternl.h>

#include <cstdio>

int main(int argc, char** argv) {
  if (argc != 2) {
    printf("Usage: %s <hive file>\n", argv[0]);
    return 1;
  }

  LONG st;
  HKEY hkey, hnestedkey;

  do {
    st = RegLoadAppKeyA(argv[1], &hkey, KEY_ALL_ACCESS, 0, 0);
    if (st != ERROR_SUCCESS) {
      break;
    }

    printf("Hive successfully loaded\n");

    st = RegOpenKeyExW(hkey, L"Test", 0, KEY_ALL_ACCESS, &hnestedkey);
    if (st != ERROR_SUCCESS) {
      break;
    }

    printf("Nested key successfully opened\n");

    for (ULONG i = 0; i < 2000; i++) {
      CHAR chKeyName[10];
      _snprintf_s(chKeyName, sizeof(chKeyName), "zzzz%.4x", i);

      HKEY hnewkey;
      st = RegCreateKeyExA(hnestedkey, chKeyName, 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hnewkey, NULL);
      if (st != ERROR_SUCCESS) {
        goto error;
      }

      printf("Key successfully created\n");

      RegCloseKey(hnewkey);
    }

    RegCloseKey(hnestedkey);
    RegCloseKey(hkey);
  } while (0);

error:
  if (st != ERROR_SUCCESS) {
    printf("Call failed with error %d\n", st);
  }

  return 0;
}
